#include <stdio.h>
#include <stdlib.h>
#include <math.h>
// 判断当前皇后放置是否合法
int place(int x[], int j) {
    for (int i = 1; i < j; i++) {
        // 判断是否在同一列或者是否在同一对角线上
        if (x[i] == x[j] || abs(j - i) == abs(x[j] - x[i])) {
            return 0; // 不合法
        }
    }
    return 1; // 合法
}
// 非递归方式解 N 皇后问题
void nQNoRec(int x[], int n) {
    int j = 1; // t 表示当前放置第 t 个皇后
    for (int i = 1; i <= n; i++) 
        x[i] = 0; 
    while (j >= 1) {
        while (x[j] < n) {
            x[j] = x[j] + 1;
            if (place(x, j)) {
                j = j + 1;
                if (j > n) { // 到达叶子节点 
                    for (int i = 1; i <= n; i++) 
                        printf("%d\t", x[i]); 
                    printf("\n");
                    j = j - 1;
                }
            }
        }
        x[j] = 0; // 回溯时，恢复当前位置的状态
        j = j - 1; // 向上回溯
    }
}

// 递归方式解 N 皇后问题
void nQueenRec(int x[], int j, int n) {
    if (j > n) {// 搜索到叶子节点  
        for (int i = 1; i <= n; i++) 
            printf("%d\t", x[i]); 
        printf("\n");
    } else {// 尝试在第 j 行放置皇后 
        for (int i = 1; i <= n; i++) {
            x[j] = i;
            printf("i=%d,j=%d\n",i,j);
            if (place(x, j)) 
                nQueenRec(x, j + 1, n);  
        }
    }
} 
int main() {
    int n = 6; // 皇后个数
    int x[n + 1]; // 存储每行皇后的位置   
    nQueenRec(x, 1, n); // 递归方式解法
    printf("****************************\n");
    nQNoRec(x, n); // 非递归方式解法
    return 0;
}
